<?php

namespace ChronopostTracking\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for resultListCancelSkybill StructType
 * @subpackage Structs
 */
class ResultListCancelSkybill extends AbstractStructBase
{
    /**
     * The errorCode
     * @var int
     */
    public $errorCode;
    /**
     * The errorMessage
     * @var string
     */
    public $errorMessage;
    /**
     * The skybills
     * @var string
     */
    public $skybills;
    /**
     * The statusCode
     * @var int
     */
    public $statusCode;
    /**
     * Constructor method for resultListCancelSkybill
     * @uses ResultListCancelSkybill::setErrorCode()
     * @uses ResultListCancelSkybill::setErrorMessage()
     * @uses ResultListCancelSkybill::setSkybills()
     * @uses ResultListCancelSkybill::setStatusCode()
     * @param int $errorCode
     * @param string $errorMessage
     * @param string $skybills
     * @param int $statusCode
     */
    public function __construct($errorCode = null, $errorMessage = null, $skybills = null, $statusCode = null)
    {
        $this
            ->setErrorCode($errorCode)
            ->setErrorMessage($errorMessage)
            ->setSkybills($skybills)
            ->setStatusCode($statusCode);
    }
    /**
     * Get errorCode value
     * @return int|null
     */
    public function getErrorCode()
    {
        return $this->errorCode;
    }
    /**
     * Set errorCode value
     * @param int $errorCode
     * @return \ChronopostTracking\StructType\ResultListCancelSkybill
     */
    public function setErrorCode($errorCode = null)
    {
        // validation for constraint: int
        if (!is_null($errorCode) && !(is_int($errorCode) || ctype_digit($errorCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($errorCode, true), gettype($errorCode)), __LINE__);
        }
        $this->errorCode = $errorCode;
        return $this;
    }
    /**
     * Get errorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->errorMessage;
    }
    /**
     * Set errorMessage value
     * @param string $errorMessage
     * @return \ChronopostTracking\StructType\ResultListCancelSkybill
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->errorMessage = $errorMessage;
        return $this;
    }
    /**
     * Get skybills value
     * @return string|null
     */
    public function getSkybills()
    {
        return $this->skybills;
    }
    /**
     * Set skybills value
     * @param string $skybills
     * @return \ChronopostTracking\StructType\ResultListCancelSkybill
     */
    public function setSkybills($skybills = null)
    {
        // validation for constraint: string
        if (!is_null($skybills) && !is_string($skybills)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($skybills, true), gettype($skybills)), __LINE__);
        }
        $this->skybills = $skybills;
        return $this;
    }
    /**
     * Get statusCode value
     * @return int|null
     */
    public function getStatusCode()
    {
        return $this->statusCode;
    }
    /**
     * Set statusCode value
     * @param int $statusCode
     * @return \ChronopostTracking\StructType\ResultListCancelSkybill
     */
    public function setStatusCode($statusCode = null)
    {
        // validation for constraint: int
        if (!is_null($statusCode) && !(is_int($statusCode) || ctype_digit($statusCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($statusCode, true), gettype($statusCode)), __LINE__);
        }
        $this->statusCode = $statusCode;
        return $this;
    }
}
